clc;
clear all;
close all;

Ts = 0.05;
N = 5;

acadoSet('problemname', 'pendulum');

DifferentialState p theta v omega;
Control F;

%% Differential equations
% TODO: complete the nonlinear dynamics HERE using the ode_function
model = [dot(p);dot(theta);dot(v);dot(omega)] == ode_fun(0,[p;theta;v;omega],F);


%% ACADO SIMexport
sim = acado.SIMexport( Ts );

sim.setModel(model);

sim.set( 'INTEGRATOR_TYPE',             'INT_RK4'    );
sim.set( 'NUM_INTEGRATOR_STEPS',        2            );

sim.exportCode('pendulum_export')

cd pendulum_export
make_acado_integrator('../integrate_pendulum')
cd ..

%% Compare results with the MATLAB function RK4_integrator
input.Ts = Ts;
input.nSteps = 2;
x0 = rand(4,1);
u0 = rand;
input.x = x0;
input.u = u0;
output = RK4_integrator(@ode, input);
output2 = integrate_pendulum(input);

output.value-output2.value
output.sensX-output2.sensX
output.sensU-output2.sensU