clear all;
close all;
clc;

x0 = [0;0;0;0];
u = 0.01;
T = 4;

% ode 45
[t_ode45,x_ode45] = ode45(@(t,x) ode(t,x,u), [0 T], x0);

% RK4 integrator
N = 80;
Ts = T/N;
x_rk4 = x0;
input.Ts = Ts;
input.nSteps = 2;
for i = 1:N
    % TODO: pass the current state value HERE
    input.x = ...;
    % TODO: pass the (constant) control input HERE
    input.u = ...;
    output = RK4_integrator( @ode, input );
    x_rk4(:,end+1) = output.value;
end
t_rk4 = [0:N].*Ts;

% Plot results:
figure;
set(gcf,'Color',[1 1 1])
subplot(221);
plot(t_ode45,x_ode45(:,1),'--g'); hold on
plot(t_rk4,x_rk4(1,:),'rx','MarkerSize',10);
xlabel('time(s)')
ylabel('p')
legend('ode45', 'RK4');
grid on;

subplot(222);
plot(t_ode45,x_ode45(:,2),'--g'); hold on
plot(t_rk4,x_rk4(2,:),'rx','MarkerSize',10);
xlabel('time(s)')
ylabel('\theta')
legend('ode45', 'RK4');
grid on;

subplot(223);
plot(t_ode45,x_ode45(:,3),'--g'); hold on
plot(t_rk4,x_rk4(3,:),'rx','MarkerSize',10);
xlabel('time(s)')
ylabel('v')
legend('ode45', 'RK4');
grid on;

subplot(224);
plot(t_ode45,x_ode45(:,4),'--g'); hold on
plot(t_rk4,x_rk4(4,:),'rx','MarkerSize',10);
xlabel('time(s)')
ylabel('\omega')
legend('ode45', 'RK4');
grid on;

